﻿using Microsoft.AspNetCore.Http;
using System.Threading.Tasks;

namespace TestProject
{
    /// <summary>
    /// 응답 가공 미들웨어
    /// </summary>
    public class ResponseProcessingMiddleware
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Field
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region Field

        /// <summary>
        /// 다음 미들웨어
        /// </summary>
        private RequestDelegate next;

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 생성자 - ResponseProcessingMiddleware(next)

        /// <summary>
        /// 생성자
        /// </summary>
        /// <param name="next">다음 미들웨어</param>
        public ResponseProcessingMiddleware(RequestDelegate next)
        {
            this.next = next;
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 호출하기 - Invoke(context)

        /// <summary>
        /// 호출하기
        /// </summary>
        /// <param name="context">HTTP 컨텍스트</param>
        /// <returns>태스크</returns>
        public async Task Invoke(HttpContext context)
        {
            await next.Invoke(context);

            if(context.Response.StatusCode == 404)
            {
                await context.Response.WriteAsync
                (
                    $"<h1>You are not authorized to access to {context.Request.Host.Host}{context.Request.Path}</h1>"
                );
            }
        }

        #endregion
    }
}